%define releasebase 1 
%define nbase blacs
%define prefix /opt/%{nbase}/%{version}/%{compilertag}/%{mpitag}
%define _libdir %{prefix}/lib
%define _bindir %{prefix}/bin
%define modulepath /opt/Modules/modulefiles/
#Set  as deafults if no command line inputs
%define as_limulus 1
%define use_ompi 1
#  do not try to build with g77 and gcc3
%define use_gnu4 1 
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
# possible MPI's
%{?_with_ompi: %{expand: %%define use_ompi 1}}
%{?_with_mpich2: %{expand: %%define use_mpich2 1}}
%{?_with_mpich2omx: %{expand: %%define use_mpich2omx 1}}
# possible build tags
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}

#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%define targetbase Limulus
%endif
# pick the compiler
%if "1" == "%{use_gnu4}"
%define compilertag gnu4
%endif
%if "1" == "%{use_pgi}"
%define compilertag pgi
%endif
%if "1" == "%{use_intel}"
%define compilertag intel
%endif
%if "1" == "%{use_pathsc}"
%define compilertag pathsc
%endif
%if "1" == "%{use_gnu3}"
%define compilertag gnu3
%endif
# select MPI
%if "1" == "%{use_ompi}"
%define mpitag openmpi
%endif
%if "1" == "%{use_mpich2omx}"
%define mpitag mpich2-omx
%endif
%if "1" == "%{use_mpich2}"
%define mpitag mpich2
%endif
#

Name: %{nbase}-%{mpitag}-%{compilertag}
BuildRequires: gcc-gfortran
BuildRequires: %{mpitag}-%{compilertag}, lapack-%{compilertag}, blas-%{compilertag}, modules

Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}
Summary: Basic Linear Algebra Communication Subprograms
Version: 1.1
License: Freely distributable
URL: http://www.netlib.org/blacs
Source0: mpiblacs.tgz
Source1: blacstester.tgz
Source2: Bmake.basement.inc
Source3: mpi_prop.ps
Source4: blacs_install.ps
Source5: mpiblacs_issues.ps
Source6: f77blacsqref.ps
Source7: cblacsqref.ps
Source8: lawn94.ps
Source9: Bmake.basement.inc.64bit
#Source10: blacs_pinfo_.c 
Requires:  %{mpitag}-%{compilertag}, lapack-%{compilertag}, blas-%{compilertag}, modules
Patch0: blacs-shared.patch

%description
The BLACS (Basic Linear Algebra Communication Subprograms) project is 
an ongoing investigation whose purpose is to create a linear algebra 
oriented message passing interface that may be implemented efficiently 
and uniformly across a large range of distributed memory platforms.

The length of time required to implement efficient distributed memory 
algorithms makes it impractical to rewrite programs for every new 
parallel machine. The BLACS exist in order to make linear algebra 
applications both easier to program and more portable. 


%prep
%setup -q -c -n %{nbase}
%setup -q -D -T -a 1 -n %{nbase}
%patch0 -p1
cd BLACS/
%ifarch ppc64 sparc64 x86_64 ia64
cp -f %{SOURCE9} ./Bmake.inc
%else
cp -f %{SOURCE2} ./Bmake.inc
%endif
%build
rpm -qf /opt/Modules/bin/modulecmd >& /dev/null
if [ $? -ne 0 ]; then
  echo "This RPM requries the BSC Modules package to build"
fi
. /etc/profile.d/modules.sh

# GNU4
%if "1" == "%{use_gnu4}"
        export CC=gcc
        export F77=gfortran
        export FFLAGS=' -O2'
%endif
# Other compilers here
#
#
# Load MPI module
echo MPITAG %{mpitag}
module list
module load mpi/%{mpitag}-%{compilertag}

cd BLACS/
CFLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-fstack-protector//g'`
RPM_OPT_FLAGS=`echo $CFLAGS`
make mpi

cd TESTING/
make
cd ../..

cp %{SOURCE3} mpi_prop.ps
cp %{SOURCE4} blacs_install.ps
cp %{SOURCE5} mpiblacs_issues.ps
cp %{SOURCE6} f77blacsqref.ps
cp %{SOURCE7} cblacsqref.ps
cp %{SOURCE8} lawn94.ps
module rm  mpi/%{mpitag}-%{compilertag}

%install
rm -fr ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}

cd BLACS/LIB
#for f in *.a *.so*; do
for f in *.a ; do
  cp -f $f ${RPM_BUILD_ROOT}%{_libdir}/$f
done
pushd ../TESTING/EXE
cp -f x*test_MPI-LINUX-0 ${RPM_BUILD_ROOT}%{_bindir}
cp -f *.dat ${RPM_BUILD_ROOT}%{_bindir}
popd
pushd ${RPM_BUILD_ROOT}%{_libdir}
for i in libmpiblacs libmpiblacsF77init libmpiblacsCinit; do
  ln -fs $i.so.1.0.0 $i.so.1
  ln -s $i.so.1.0.0 $i.so
done
popd

%post
/sbin/ldconfig 2>/dev/null
#create the module file
cat <<EOF >%{modulepath}/%{name}
#%Module1.0#######################################################################
##  %{name} modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing %{name} version %{version}.\n"
}

conflict blacs*

module-whatis "%{name} %{version}"
module-log error none

set blacsroot %{prefix}

if [ module-info mode load ] {
        setenv BLACS_PATH \$blacsroot/lib
}
if [ module-info mode remove ] {
        unsetenv BLACS_PATH
}
EOF

%postun
/sbin/ldconfig 2>/dev/null
/bin/rm %{modulepath}/%{name}
%clean
rm -fr ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root,0755)
%doc mpi_prop.ps blacs_install.ps mpiblacs_issues.ps f77blacsqref.ps cblacsqref.ps lawn94.ps
%{_bindir}/x*test_MPI-LINUX-0
%{_bindir}/*.dat
%{_libdir}/libmpiblacs*.a
%{_libdir}/libmpiblacs*.so.*
%{_libdir}/libmpiblacs*.so

%changelog
* Wed Apr 20 2011 deadline <deadline@basement-supercomputing.com>
- added mpi and compiler tags for multiple builds
* Fri Apr 23 2010 deadline  <deadline@basement-supercomputing.com>
- merged devel and placed in /opt for Basement
- added module file
* Wed Dec 20 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-24.1
- updated bmake files to include new lam-devel header path

* Mon Sep 11 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-24
- FC-5+ needs lam-devel as a BR

* Mon Sep 11 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-23
- bump for FC-6

* Fri Apr  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-22
- FC-5+ also needs -L libdir/lam

* Fri Apr  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-21
- FC-5+ needs includedir/lam

* Fri Apr  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-20
- fix lam BR

* Tue Feb 28 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-19
- fix broken bits in shared lib (no -fstack-protector for us)

* Mon Dec 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-18
- rebuild for gcc4.1

* Sun Jul 31 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-17
- fix g77 for FC-3 spec

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-16
- remove ppc hack

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-15
- Fix typo in fix. :/

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-12
- fix INTFACE for FC-4+

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-11
- bump for new tag

* Mon Jun 27 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-10
- split static lib and .so into -devel package
- fix Bmake files for shared library support
- build shared libraries

* Tue May 10 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-8
- g77 needs some special compile flags, edited Bmake.inc*

* Mon May  9 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-7
- remove hardcoded dist tags

* Thu May  5 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-6
- fix 64bit issues

* Sun Apr 24 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-5
- use dist tag
- fix fc3 package sources and dependencies

* Tue Apr 19 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-4
- fix buildroot
- add gcc-gfortran as a BuildRequires (gcc-g77)

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-3
- backout shared patch

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-2
- rename libs to what scalapack thinks they should be called

* Mon Apr 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.1-1
- initial package creation
